//+------------------------------------------------------------------+
//|                                                        .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int MN = 123;

extern double Lot = 0.01;
extern double Mnozhitel = 2;

int cik;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
double lots = LotMartingal (OP_SELL);
double lotb = LotMartingal (OP_BUY);
OrderSend (Symbol(), OP_SELL, lots, Bid, 3, 0, 0, 0, MN, 0, CLR_NONE);
OrderSend (Symbol(), OP_BUY, lotb, Ask, 3, 0, 0, 0, MN, 0, CLR_NONE);

//----
   return(0);
  }
//+------------------------------------------------------------------+

double LotMartingal (int OrType)
//    ,       ,    
//     = 
{
if (OrType > 5 && OrType < 0)
     {
     Print ("LotMartingal (int OrType)   ");
     return (-1);
     }
     
double lot1, lot2 = 0;
int cik;
int err;
int errs = 100;

for (cik = OrdersTotal() - 1; cik >= 0; cik --)
     {
     if (!OrderSelect (cik, SELECT_BY_POS, MODE_TRADES))
          {
          err = GetLastError();          
          Print (" ", err);           
          if( err==4 || err==137 ||err==146 || err==136 && errs > 0)
               {
               errs --;
               cik ++;
               Sleep (1000);
               continue;
               }      
          }  
     else
          if (OrderMagicNumber() == MN
             && OrderSymbol() == Symbol()
             && OrderType() == OrType)           
               {                 
               lot1 = OrderLots();// 
               if (lot1 > lot2)
                    lot2 = lot1;
                 
               //lot2 = OrderLots();//  
               //break;               
               }            
     }
     
if (lot2 == 0)
     {
     lot2 = Lot;
     return (lot2);
     }
     
if (lot2 > 0)
     {
     lot2 = lot2 * Mnozhitel; 
     NormalizeDouble (lot2, Digits); 
     }  
return (lot2);                      
}